<template>
  <div
    class="ui-progress"
    :class="classList"
    role="progressbar"
  >
    <div
      class="progress"
      :style="progressStyleList"
    />
    <div
      class="uikit-absolute uikit-left-1/2 uikit-top-1/2 uikit-transform -uikit-translate-x-1/2 -uikit-translate-y-1/2"
      role="presentation"
    >
      <slot name="content" />
    </div>
  </div>
</template>

<script lang="ts">
  import { computed, defineComponent } from 'vue'

  export default defineComponent({
    name: 'ui-progress',
    props: {
      value: {
        type: Number,
        default: 0,
      },
      min: {
        type: Number,
        default: 0,
      },
      max: {
        type: Number,
        default: Number.MAX_SAFE_INTEGER,
      },
      size: {
        default: '24',
        validator: (value: string) => ['24'].includes(value),
      },
    },
    setup(props) {
      const progressStyleList = computed(() => {
        const percent = (props.value / props.max) * 100

        return {
          width: `${percent}%`,
        }
      })

      const classList = computed(() => ({
        [`-size-${props.size}`]: true,
      }))

      return {
        classList,
        progressStyleList,
      }
    },
  })
</script>

<style>
  .ui-progress {
    border-radius: 35px;
    @apply uikit-bg-black uikit-relative uikit-overflow-hidden uikit-w-full uikit-text-white;
  }

  .ui-progress.-size-24 {
    @apply uikit-h-24;
  }

  .ui-progress .progress {
    @apply uikit-bg-green-original uikit-h-full;
  }
</style>
